#ifndef FSGUIDIALOGUTIL_IS_INCLUDED
#define FSGUIDIALOGUTIL_IS_INCLUDED
/* { */

#include <ysclass.h>
#include "fsguidialog.h"
#include "fsguiclipboard.h"

/*! Deprecated and left for backward compatibility.  Use FsGuiMessageDialog instead. */
class FsGuiMessageBoxDialog : public FsGuiDialog
{
private:
	FsGuiStatic *label;
	FsGuiDialogItem *yesBtn,*noBtn,*btn;
	FsGuiButton *copyBtn;
	int returnCodeYes,returnCodeNo;

public:
	void Make(
	    const wchar_t title[],const wchar_t msg[],const wchar_t yesBtn[],const wchar_t noBtn[],
	    int returnCodeYes=(int)YSOK,int returnCodeNo=(int)YSERR);
	void Make(
	    const wchar_t title[],const wchar_t msg[],const wchar_t yesBtn[],const wchar_t noBtn[],const wchar_t copyBtn[],
	    int returnCodeYes=(int)YSOK,int returnCodeNo=(int)YSERR);
	virtual void OnKeyDown(int fsKey,YSBOOL shift,YSBOOL ctrl,YSBOOL alt);
	virtual void OnButtonClick(FsGuiButton *btn);
};

////////////////////////////////////////////////////////////

template <const int N>
class FsGuiInputNumberDialogTemplate : public FsGuiDialog
{
public:
	FsGuiTextBox *numTxt[N];
	FsGuiButton *okBtn,*cancelBtn;
	int returnCodeYes,returnCodeNo;

	void OnButtonClickTemplate(FsGuiButton *btn);
};

class FsGuiInputNumberDialog : public FsGuiInputNumberDialogTemplate <1>
{
public:
	void Make(
	    const double defNumber,const int belowDecimal,
	    const wchar_t title[],const wchar_t msg[],const wchar_t label[],
	    const wchar_t yesBtn[],const wchar_t noBtn[],int returnCodeYes,int returnCodeNo);
	const double GetNumber(void) const;

	virtual void OnButtonClick(FsGuiButton *btn);
};

class FsGuiInputTwoNumberDialog : public FsGuiInputNumberDialogTemplate <2>
{
public:
	void Make(
	    const double dflt[2],const int belowDecimal,
	    const wchar_t msg[],const wchar_t title[],const wchar_t label1[],const wchar_t label2[],
	    const wchar_t yesBtn[],const wchar_t noBtn[],int returnCodeYes,int returnCodeNo);
	const double GetNumber(int idx) const;

	virtual void OnButtonClick(FsGuiButton *btn);
};

/* } */
#endif
