#include "fsguinumberdialog.h"
#include <fssimplewindow.h>

FsGuiNumberDialog::FsGuiNumberDialog()
{
	numberTxt=NULL;
	okBtn=NULL;
	cancelBtn=NULL;
}

FsGuiNumberDialog::~FsGuiNumberDialog()
{
}

/* static */ FsGuiNumberDialog *FsGuiNumberDialog::Create(void)
{
	FsGuiNumberDialog *dlg=new FsGuiNumberDialog;
	return dlg;
}

/* static */ void FsGuiNumberDialog::Delete(FsGuiNumberDialog *ptr)
{
	delete ptr;
}

void FsGuiNumberDialog::Make(const wchar_t numberLabelIn[],const wchar_t okMsgIn[],const wchar_t cancelMsgIn[])
{
	const wchar_t *okMsg=(NULL!=okMsgIn ? okMsgIn : L"OK");
	const wchar_t *cancelMsg=(NULL!=cancelMsgIn ? cancelMsgIn : L"Cancel");
	const wchar_t *numberLabel=(NULL!=numberLabelIn ? numberLabelIn : L"Number");

	if(NULL==okBtn)
	{
		okBtn=AddTextButton(0,FSKEY_ENTER,FSGUI_PUSHBUTTON,okMsg,YSTRUE);
		cancelBtn=AddTextButton(0,FSKEY_ESC,FSGUI_PUSHBUTTON,cancelMsg,YSFALSE);
		numberTxt=AddTextBox(0,FSKEY_NULL,FsGuiTextBox::HORIZONTAL,numberLabel,16,YSTRUE);
	}

	Fit();
}

void FsGuiNumberDialog::SetRealNumber(const double value)
{
	numberTxt->SetRealNumber(value,6);
}

void FsGuiNumberDialog::SetInteger(const int value)
{
	numberTxt->SetInteger(value);
}

const double FsGuiNumberDialog::GetRealNumber(void) const
{
	return numberTxt->GetRealNumber();
}

const int FsGuiNumberDialog::GetInteger(void) const
{
	return numberTxt->GetInteger();
}

/* virtual */ void FsGuiNumberDialog::OnButtonClick(FsGuiButton *btn)
{
	if(okBtn==btn)
	{
		CloseModalDialog(YSOK);
	}
	else if(cancelBtn==btn)
	{
		CloseModalDialog(YSERR);
	}
}
