#include <ysclass.h>
#include "../fsguiclipboard.h"
#include <windows.h>

YSRESULT FsGuiCopyStringToClipBoard(const YsString &str)
{
	if(TRUE==OpenClipboard(NULL))
	{
		EmptyClipboard();

		const char *newTxt=str;
		HANDLE hClipBoard=GlobalAlloc(GMEM_MOVEABLE,strlen(newTxt)+1);
		if(NULL!=hClipBoard)
		{
			char *str=(char *)GlobalLock(hClipBoard);
			if(NULL!=str)
			{
				strcpy(str,newTxt);
				GlobalUnlock(hClipBoard);
				if(NULL!=SetClipboardData(CF_TEXT,hClipBoard))
				{
				}
			}
		}
		CloseClipboard();
	}
	return YSOK;
}

YSRESULT FsGuiCopyStringFromClipBoard(YsString &str)
{
	if(TRUE==IsClipboardFormatAvailable(CF_TEXT) &&
	   TRUE==OpenClipboard(NULL))
	{
		HANDLE hClipBoard=GetClipboardData(CF_TEXT);
		if(NULL!=hClipBoard)
		{
			const char *strPtr=(const char *)GlobalLock(hClipBoard);
			if(NULL!=strPtr)
			{
				str.Set(strPtr);
			}
			else
			{
				str.Set("");
			}
			GlobalUnlock(hClipBoard);
		}
		CloseClipboard();
	}
	return YSOK;
}





