/* ////////////////////////////////////////////////////////////

  File Name: ysairfoil_clarky.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <math.h>

#include <ysclass.h>
#include "ysairfoil.h"

#include "ysairfoil_clarky_data.h"



void AirfoilClarkY::Generate(int numDivision)
{
	YsArray <YsVec3> upper,lower;

	const double numSample=YsAirfoil_ClarkY_numSample;
	const double *sample=YsAirfoil_ClarkY_sample;

	for(int j=0; j<=numSample-3; j+=3)
	{
		YsVec3 pos;
		pos.Set(sample[j],sample[j+1],0.0);
		upper.Append(pos);
		pos.Set(sample[j],sample[j+2],0.0);
		lower.Append(pos);
	}



	int ix=0,step=1;

	YsArray <double> tArray;
	for(int i=0; i<numDivision; ++i)
	{
		tArray.Append((double)ix);
		ix+=step;

		if(i<numDivision/2)
		{
			if(1<=i)
			{
				++step;
			}
			if(2<=i)
			{
				++step;
			}
		}
		else if(numDivision*2/3<i)
		{
			if(1<step)
			{
				--step;
			}
		}
	}

	for(int i=0; i<tArray.GetN(); ++i)
	{
		tArray[i]/=tArray.GetEnd();
	}

	ResampleFromUpperAndLower(upper,lower,tArray);
}
