/* ////////////////////////////////////////////////////////////

  File Name: configmenu.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef CONFIGMENU_IS_INCLUDED
#define CONFIGMENU_IS_INCLUDED
/* { */

#include <ysclass.h>
#include <fsgui.h>

class PolyCreConfigDialog : public FsGuiDialog
{
private:
	FsGuiDropList *coordSysDrp;
	FsGuiStatic *defDataPath;
	FsGuiButton *setDefDataPathBtn;

	FsGuiColorPalette *bgColorPlt[3];

	FsGuiButton *okBtn,*cancelBtn,*setDefaultBtn;

	FsGuiMessageBoxDialog *mbox;
	class FsGuiFileDialog *fdlg;

	class FsGui3DMainCanvas *canvas;

	PolyCreConfigDialog();
	~PolyCreConfigDialog();
	const PolyCreConfigDialog &operator=(const PolyCreConfigDialog &){}

public:
	static PolyCreConfigDialog *Create(void);
	static void Delete(PolyCreConfigDialog *ptr);

	static void BeginSelectDefaultDataDirectory(FsGuiControlBase *,FsGuiDialog *,int returnValue);
	static void SelectDefaultDataDirectory_FileSelected(FsGuiControlBase *,FsGuiDialog *,int returnValue);

	void Make(class PolyCreConfig &cfg,class FsGui3DMainCanvas *canvas);
	void SetFromConfig(class PolyCreConfig &cfg);
	void Retrieve(class PolyCreConfig &cfg);

	virtual void OnButtonClick(FsGuiButton *btn);
};

/* } */
#endif
