/* ////////////////////////////////////////////////////////////

  File Name: filemenu.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "fsgui3dapp.h"
#include "file_slideshowdialog.h"

#include <fsguifiledialog.h>
#include <ysgl.h>
#include <ysport.h>
#include <ysshellkernel.h>

#include "textresource.h"


/*static*/void FsGui3DMainCanvas::File_New(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;

	YsShellDnmContainer <YsShellExtEdit>::Node *newSlHd=canvas->shlGrp.CreateShell(NULL);
	if(NULL!=newSlHd)
	{
		canvas->slHd=newSlHd;

		canvas->needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_ALL;
		canvas->needRemakeDrawingBuffer_for_OtherShell=(unsigned int)NEED_REMAKE_DRAWING_ALL;
		canvas->SetNeedRedraw(YSTRUE);
	}
}

/*static*/void FsGui3DMainCanvas::File_Open(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;

	YsString dataDir;
	dataDir.EncodeUTF8 <wchar_t> (canvas->GetDataDir());

	YsString def;
	def.MakeFullPathName(dataDir,"*.srf");
	// YsString last(scn.GetLastOpenedFilename()),def;
	// if(last.Strlen()>0)
	// {
	// 	YsString pth,fil;
	// 	last.SeparatePathFile(pth,fil);
	// 	def.MakeFullPathName(pth,"*.fld");
	// }
	// else
	// {
	// 	def.MakeFullPathName(scnDir,"*.fld");
	// }

	canvas->fdlg->Initialize();
	canvas->fdlg->mode=FsGuiFileDialog::MODE_OPEN;
	canvas->fdlg->multiSelect=YSFALSE;
	canvas->fdlg->title.Set(L"Open");
	canvas->fdlg->fileExtensionArray.Append(L".srf");
	canvas->fdlg->fileExtensionArray.Append(L".stl");
	canvas->fdlg->fileExtensionArray.Append(L".obj");
	canvas->fdlg->fileExtensionArray.Append(L".dnm");
	canvas->fdlg->defaultFileName.SetUTF8String(def);
	canvas->fdlg->SetCloseModalCallBack(File_Open_FileSelected);
	canvas->AttachModalDialog(canvas->fdlg);
}

/*static*/void FsGui3DMainCanvas::File_Open_FileSelected(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK==(YSRESULT)returnValue)
	{
		auto &canvas=*(FsGui3DMainCanvas *)appPtr;

		YsWString ful(canvas.fdlg->selectedFileArray[0]);

		YsWString ext;
		ful.GetExtension(ext);
		ext.Capitalize();
		if(0==ext.Strcmp(ext,L".DNM"))
		{
			YsArray <const YsShellDnmContainer <YsShellExtEdit>::Node *> allNode;
			canvas.shlGrp.GetNodePointerAll(allNode);

			for(YSSIZE_T idx=0; idx<allNode.GetN(); ++idx)
			{
				if(YSTRUE==allNode[idx]->IsModified())
				{
					canvas.YesNoDialog(
					    FSGUI_DLG_OPENDNM_CONFIRMCLOSE_TITLE,
					    FSGUI_DLG_OPENDNM_CONFIRMCLOSE_MESSAGE,
					    FSGUI_COMMON_OK,
					    FSGUI_COMMON_CANCEL,
					    File_OpenDnm_ConfirmCloseCallBack);
					return;
				}
			}
		}

		canvas.LoadGeneral(canvas.fdlg->selectedFileArray[0],NULL);
	}
}

/*static*/ void FsGui3DMainCanvas::File_OpenDnm_ConfirmCloseCallBack(FsGuiControlBase *appPtr,FsGuiDialog *,int returnCode)
{
	if((int)YSOK==returnCode)
	{
		FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
		canvas.LoadGeneral(canvas.fdlg->selectedFileArray[0],NULL);
	}
}


void FsGui3DMainCanvas::File_Open_AfterOpenFile(YsShellDnmContainer <YsShellExtEdit>::Node *newSlHd,const wchar_t fn[])
{
	if(NULL!=slHd &&
	   YSTRUE==slHd->IsEmptyAndHasNeverBeenEdited() &&
	   0==shlGrp.GetNumChildNode(slHd))
	{
		shlGrp.DeleteShell(slHd);
	}

	slHd=newSlHd;

	{
		YsVec3 allBbx[2];
		shlGrp.GetBoundingBox(allBbx);
		drawEnv.SetTargetBoundingBox(allBbx[0],allBbx[1]);
		drawEnv.SetViewDistance((allBbx[1]-allBbx[0]).GetLength()*1.5);
	}

	viewControlDlg->SaveLastView();
	YsVec3 bbx[2];
	slHd->GetBoundingBox(bbx[0],bbx[1]);
	drawEnv.SetViewTarget((bbx[0]+bbx[1])/2.0);
	drawEnv.SetZoom(1.0);


	// Is this a relative-path or full path file name?
	{
		YsWString ful,cwd;
		YsFileIO::Getcwd(cwd);
		ful.MakeFullPathName(cwd,fn);

		FILE *fp=YsFileIO::Fopen(ful,"rb");
		if(NULL!=fp)
		{
			fclose(fp); // No, fn was a relative path.
		}
		else
		{
			ful.Set(fn); // Yes, fn was a full-path.
		}

		lastAccessedFileName.Set(ful);
		AddRecentlyUsedFile(ful);
	}


	needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_ALL;
	needRemakeDrawingBuffer_for_OtherShell=(unsigned int)NEED_REMAKE_DRAWING_ALL;
	SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::File_Save(void *appPtr,FsGuiPopUpMenu *menu,FsGuiPopUpMenuItem *menuItem)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		YsWString fn(canvas.slHd->GetFileName());
		if(0==fn.Strlen())
		{
			canvas.File_SaveAs(appPtr,menu,menuItem);
		}
		else
		{
			canvas.SaveGeneral(*canvas.slHd,canvas.slHd->GetFileName());
		}
	}
}

/*static*/void FsGui3DMainCanvas::File_SaveAs(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;

	YsString dataDir;
	dataDir.EncodeUTF8 <wchar_t> (canvas->GetDataDir());

	YsString def;
	def.MakeFullPathName(dataDir,"*.srf");

	// YsString last(scn.GetLastOpenedFilename()),def;
	// if(last.Strlen()>0)
	// {
	// 	YsString pth,fil;
	// 	last.SeparatePathFile(pth,fil);
	// 	def.MakeFullPathName(pth,"*.fld");
	// }
	// else
	// {
	// 	def.MakeFullPathName(scnDir,"*.fld");
	// }

	canvas->fdlg->Initialize();
	canvas->fdlg->mode=FsGuiFileDialog::MODE_SAVE;
	canvas->fdlg->multiSelect=YSFALSE;
	canvas->fdlg->title.Set(L"Save As");
	canvas->fdlg->fileExtensionArray.Append(L".srf");
	canvas->fdlg->fileExtensionArray.Append(L".stl");
	canvas->fdlg->fileExtensionArray.Append(L".obj");
	canvas->fdlg->defaultFileName.SetUTF8String(def);
	canvas->fdlg->SetCloseModalCallBack(File_SaveAs_FileSelected);
	canvas->AttachModalDialog(canvas->fdlg);
}

/*static*/void FsGui3DMainCanvas::File_SaveAs_FileSelected(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;
	if(YSOK==(YSRESULT)returnValue)
	{
		YsWString ful=canvas->fdlg->selectedFileArray[0];
		YsWString ext;
		ful.GetExtension(ext);

		ext.Capitalize();
		if(0==ext.Strcmp(ext,L".STL"))
		{
			canvas->YesNoDialog(FSGUI_WARNING_STLWARNINGTITLE,FSGUI_WARNING_STLWARNING,FSGUI_COMMON_OK,FSGUI_COMMON_CANCEL,File_SaveAs_STLChecked);
		}
		else
		{
			canvas->File_SaveAs_CheckOverwrite();
		}
	}
}

/*static*/void FsGui3DMainCanvas::File_SaveAs_STLChecked(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK==(YSRESULT)returnValue)
	{
		FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;
		canvas->File_SaveAs_CheckOverwrite();
	}
}

void FsGui3DMainCanvas::File_SaveAs_CheckOverwrite(void)
{
	FILE *fp=YsFileIO::Fopen(fdlg->selectedFileArray[0],"rb");
	if(NULL!=fp)
	{
		fclose(fp);
		YesNoDialog(FSGUI_DLG_CONFIRMOVERWRITE_TITLE,FSGUI_DLG_CONFIRMOVERWRITE_MESSAGE,FSGUI_COMMON_OK,FSGUI_COMMON_CANCEL,File_SaveAs_ConfirmOverwriteCallBack);
		SetNeedRedraw(YSTRUE);
	}
	else
	{
		File_SaveAs_PassedOverWriteCheck(fdlg->selectedFileArray[0]);
	}
}

/*static*/void FsGui3DMainCanvas::File_SaveAs_ConfirmOverwriteCallBack(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK==(YSRESULT)returnValue)
	{
		FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;
		printf("Passed overwrite check.\n");
		canvas->File_SaveAs_PassedOverWriteCheck(canvas->fdlg->selectedFileArray[0]);
	}
}

void FsGui3DMainCanvas::File_SaveAs_PassedOverWriteCheck(const wchar_t fn[])
{
	if(NULL!=slHd)
	{
		SaveGeneral(*slHd,fn);

		// Is this a relative-path or full path file name?
		{
			YsWString ful,cwd;
			YsFileIO::Getcwd(cwd);
			ful.MakeFullPathName(cwd,fn);

			FILE *fp=YsFileIO::Fopen(ful,"rb");
			if(NULL!=fp)
			{
				fclose(fp); // No, fn was a relative path.
			}
			else
			{
				ful.Set(fn); // Yes, fn was a full-path.
			}

			lastAccessedFileName.Set(ful);
			AddRecentlyUsedFile(ful);
		}
	}
}



/*static*/ void FsGui3DMainCanvas::File_Exit(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;

	YsArray <const YsShellDnmContainer <YsShellExtEdit>::Node *> allNode;
	canvas->shlGrp.GetNodePointerAll(allNode);

	for(YSSIZE_T idx=0; idx<allNode.GetN(); ++idx)
	{
		if(YSTRUE==allNode[idx]->IsModified())
		{
			canvas->YesNoDialog(
			    FSGUI_DLG_CONFIRMEXIT_TITLE,
			    FSGUI_DLG_CONFIRMEXIT_MESSAGE,
			    FSGUI_COMMON_OK,
			    FSGUI_COMMON_CANCEL,
			    File_Exit_ConfirmExitCallBack);
			return;
		}
	}

	// if(YSTRUE==shlGrp->DnmTreeIsModified())
	// {
	//		canvas->YesNoDialog(L"Confirm Exit?",
	//		    L"Dynamic Model structure/motion has been modified. Exit anyway?",
	//		    L"Yes",L"No",
	//		    File_Exit_ConfirmExitCallBack);
	// 		return;
	// }

	FsGui3DSetAppMustTerminate(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::File_Exit_ConfirmExitCallBack(FsGuiControlBase *,FsGuiDialog *,int returnValue)
{
	if(YSTRUE==(YSBOOL)returnValue)
	{
		FsGui3DSetAppMustTerminate(YSTRUE);
	}
}



/*static*/ void FsGui3DMainCanvas::File_Close(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;

	if(NULL!=canvas->Slhd() && YSTRUE==canvas->Slhd()->IsModified())
	{
		canvas->YesNoDialog(
		    FSGUI_DLG_CONFIRMCLOSE_TITLE,
		    FSGUI_DLG_CONFIRMCLOSE_MESSAGE,
		    FSGUI_COMMON_OK,
		    FSGUI_COMMON_CANCEL,
		    File_Close_ConfirmCloseCallBack);
		return;
	}
	canvas->File_Close_Confirmed();
}

/*static*/ void FsGui3DMainCanvas::File_Close_ConfirmCloseCallBack(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	FsGui3DMainCanvas *canvas=(FsGui3DMainCanvas *)appPtr;
	if(YSTRUE==(YSBOOL)returnValue)
	{
		canvas->File_Close_Confirmed();
	}
}

void FsGui3DMainCanvas::File_Close_Confirmed(void)
{
	if(NULL!=slHd)
	{
		auto nextSlHd=slHd;

		YsArray <YsShellDnmContainer <YsShellExtEdit>::Node *> allNode;
		shlGrp.GetNodePointerAll(allNode);
		for(YSSIZE_T idx : allNode.AllIndex())
		{
			if(slHd==allNode[idx])
			{
				nextSlHd=allNode.GetCyclic(idx+1);
				break;
			}
		}

		if(nextSlHd==slHd)
		{
			nextSlHd=NULL;
		}

		shlGrp.DeleteShell(slHd);

		Edit_ClearUIMode();

		if(NULL==nextSlHd)
		{
			File_New(this,NULL,NULL);
		}
		else
		{
			slHd=nextSlHd;
		}
		needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_ALL;
		needRemakeDrawingBuffer_for_OtherShell=(unsigned int)NEED_REMAKE_DRAWING_ALL;
		SetNeedRedraw(YSTRUE);
	}
printf("%s %d\n",__FUNCTION__,__LINE__);
}

////////////////////////////////////////////////////////////

PolyCreSlideShowDialog::PolyCreSlideShowDialog()
{
	canvas=NULL;
	nextBtn=NULL;
	prevBtn=NULL;
	cancelBtn=NULL;
}

PolyCreSlideShowDialog::~PolyCreSlideShowDialog()
{
}

/*static*/ PolyCreSlideShowDialog *PolyCreSlideShowDialog::Create(class FsGui3DMainCanvas *canvas)
{
	PolyCreSlideShowDialog *dlg=new PolyCreSlideShowDialog;
	dlg->canvas=canvas;
	return dlg;
}

/*static*/ void PolyCreSlideShowDialog::Delete(PolyCreSlideShowDialog *ptr)
{
	delete ptr;
}

YSRESULT PolyCreSlideShowDialog::Make(void)
{
	if(NULL==nextBtn)
	{
		FsGuiDialog::Initialize();
		changeViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,FSGUI_DLG_SLIDESHOW_CHANGEVIEW,YSFALSE);
		prevBtn=AddTextButton(0,FSKEY_LEFT,FSGUI_PUSHBUTTON,FSGUI_DLG_SLIDESHOW_PREV,YSFALSE);
		nextBtn=AddTextButton(0,FSKEY_RIGHT,FSGUI_PUSHBUTTON,FSGUI_DLG_SLIDESHOW_NEXT,YSFALSE);
		cancelBtn=AddTextButton(0,FSKEY_ESC,FSGUI_PUSHBUTTON,FSGUI_COMMON_CANCEL,YSFALSE);

		SetArrangeType(FSDIALOG_ARRANGE_TOP_LEFT);
		SetBackgroundAlpha(0.3);
		Fit();
	}

	return YSOK;
}

void PolyCreSlideShowDialog::OnButtonClick(FsGuiButton *btn)
{
	auto &canvas=*(this->canvas);
	if(btn==prevBtn)
	{
		const YsVec3 prevViewTarget=canvas.drawEnv.GetViewTarget();
		const double prevViewDist=canvas.drawEnv.GetViewDistance();
		const double prevOrthoHeght=canvas.drawEnv.GetOrthogonalProjectionHeight();
		const double prevZoom=canvas.drawEnv.GetZoom();

		if(0<fileNamePtr)
		{
			canvas.slHd=slHd;  // Tentatively make it current.  Current shell will (may) be deleted in the next loop.

			auto children=slHd->children; // Make a copy.  It changes as deleted.
			for(auto child : children)
			{
				canvas.shlGrp.DeleteShell(child);
			}
			--fileNamePtr;
			canvas.LoadGeneral(fileNameArray[fileNamePtr],slHd);

			if(0==fileNamePtr)
			{
				prevBtn->Disable();
			}
			if(fileNamePtr+1<fileNameArray.GetN())
			{
				nextBtn->Enable();
			}
		}

		if(YSTRUE!=changeViewBtn->GetCheck())
		{
			canvas.drawEnv.SetViewTarget(prevViewTarget);
			canvas.drawEnv.SetViewDistance(prevViewDist);
			canvas.drawEnv.SetOrthogonalProjectionHeight(prevOrthoHeght);
			canvas.drawEnv.SetZoom(prevZoom);
		}
	}
	else if(btn==nextBtn)
	{
		const YsVec3 prevViewTarget=canvas.drawEnv.GetViewTarget();
		const double prevViewDist=canvas.drawEnv.GetViewDistance();
		const double prevOrthoHeght=canvas.drawEnv.GetOrthogonalProjectionHeight();
		const double prevZoom=canvas.drawEnv.GetZoom();

		if(fileNamePtr<fileNameArray.GetN()-1)
		{
			canvas.slHd=slHd;  // Tentatively make it current.  Current shell will (may) be deleted in the next loop.

			auto children=slHd->children; // Make a copy.  It changes as deleted.
			for(auto child : children)
			{
				canvas.shlGrp.DeleteShell(child);
			}
			++fileNamePtr;
			canvas.LoadGeneral(fileNameArray[fileNamePtr],slHd);

			if(fileNamePtr==fileNameArray.GetN()-1)
			{
				nextBtn->Disable();
			}
			if(0<fileNamePtr)
			{
				prevBtn->Enable();
			}
		}

		if(YSTRUE!=changeViewBtn->GetCheck())
		{
			canvas.drawEnv.SetViewTarget(prevViewTarget);
			canvas.drawEnv.SetViewDistance(prevViewDist);
			canvas.drawEnv.SetOrthogonalProjectionHeight(prevOrthoHeght);
			canvas.drawEnv.SetZoom(prevZoom);
		}
	}
	else if(btn==cancelBtn)
	{
		canvas.Edit_ClearUIMode();  // This will call File_SlideShow_ModeCleanUpCallBack
	}
}

/*static*/ void FsGui3DMainCanvas::File_SlideShow(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;

	YsString dataDir;
	dataDir.EncodeUTF8 <wchar_t> (canvas.GetDataDir());

	YsString def;
	def.MakeFullPathName(dataDir,"*.srf");
	// YsString last(scn.GetLastOpenedFilename()),def;
	// if(last.Strlen()>0)
	// {
	// 	YsString pth,fil;
	// 	last.SeparatePathFile(pth,fil);
	// 	def.MakeFullPathName(pth,"*.fld");
	// }
	// else
	// {
	// 	def.MakeFullPathName(scnDir,"*.fld");
	// }

	canvas.fdlg->Initialize();
	canvas.fdlg->mode=FsGuiFileDialog::MODE_OPEN;
	canvas.fdlg->multiSelect=YSTRUE;
	canvas.fdlg->title.Set(L"Slide Show");
	canvas.fdlg->fileExtensionArray.Append(L".srf");
	canvas.fdlg->fileExtensionArray.Append(L".stl");
	canvas.fdlg->fileExtensionArray.Append(L".dnm");
	canvas.fdlg->defaultFileName.SetUTF8String(def);
	canvas.fdlg->SetCloseModalCallBack(File_SlideShow_FileSelected);
	canvas.AttachModalDialog(canvas.fdlg);
}

/*static*/ void FsGui3DMainCanvas::File_SlideShow_FileSelected(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK==(YSRESULT)returnValue)
	{
		FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
		if(0<canvas.fdlg->selectedFileArray.GetN())
		{
			canvas.Edit_ClearUIMode();

			canvas.ModeCleanUpCallBack=File_SlideShow_ModeCleanUpCallBack;

			canvas.slideShowDlg->Make();
			canvas.AddDialog(canvas.slideShowDlg);
			canvas.ArrangeDialog();

			canvas.slideShowDlg->fileNamePtr=0;
			canvas.slideShowDlg->fileNameArray=canvas.fdlg->selectedFileArray;
			canvas.slideShowDlg->slHd=canvas.shlGrp.CreateShell(NULL);

			canvas.slideShowDlg->prevBtn->Disable();
			if(1>=canvas.fdlg->selectedFileArray.GetN())
			{
				canvas.slideShowDlg->nextBtn->Disable();
			}

			canvas.LoadGeneral(canvas.fdlg->selectedFileArray[0],canvas.slideShowDlg->slHd);

			canvas.needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_ALL;
			canvas.needRemakeDrawingBuffer_for_OtherShell=(unsigned int)NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ YSRESULT FsGui3DMainCanvas::File_SlideShow_ModeCleanUpCallBack(FsGui3DMainCanvas &canvas)
{
	canvas.shlGrp.DeleteShell(canvas.slideShowDlg->slHd);
	canvas.slHd=canvas.shlGrp.GetFirstRootNode();
	if(NULL==canvas.slHd)
	{
		canvas.File_New(&canvas,NULL,NULL);
	}

	canvas.needRemakeDrawingBuffer=(unsigned int)FsGui3DMainCanvas::NEED_REMAKE_DRAWING_ALL;
	canvas.needRemakeDrawingBuffer_for_OtherShell=(unsigned int)FsGui3DMainCanvas::NEED_REMAKE_DRAWING_ALL;
	canvas.SetNeedRedraw(YSTRUE);

	return YSOK;
}

/* static */ void FsGui3DMainCanvas::File_GetInfo_Statistics(void *appPtr,FsGuiPopUpMenu *menu,FsGuiPopUpMenuItem *)
{
	auto &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		const int nVtx=canvas.slHd->GetNumVertex();
		const int nPlg=canvas.slHd->GetNumPolygon();
		const int nCe=canvas.slHd->GetNumConstEdge();
		const int nFg=canvas.slHd->GetNumFaceGroup();

		YsString msg;
		msg.Printf(
		    "%d vertices.\n"
		    "%d polygons.\n"
		    "%d constraint edges.\n"
		    "%d face groups.\n",
		    nVtx,
		    nPlg,
		    nCe,
		    nFg);

		YsWString wMsg;
		wMsg.SetUTF8String(msg);
		canvas.MessageDialog(FSGUI_MENU_FILE_GETINFO_STATISTICS,wMsg,FSGUI_DLG_COMMON_COPYTOCLIPBOARD);
	}
}

/* static */ void FsGui3DMainCanvas::File_GetInfo_Volume(void *appPtr,FsGuiPopUpMenu *menu,FsGuiPopUpMenuItem *)
{
	auto &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		const double vol=canvas.slHd->ComputeVolume();

		YsString msg;
		msg.Printf("Volume %.10lf",vol);

		YsWString wMsg;
		wMsg.SetUTF8String(msg);
		canvas.MessageDialog(FSGUI_MENU_FILE_GETINFO_VOLUME,wMsg,FSGUI_DLG_COMMON_COPYTOCLIPBOARD);
	}
}

/* static */ void FsGui3DMainCanvas::File_Recent(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *itm)
{
	const wchar_t *wfn=itm->GetString();
	auto &canvas=*(FsGui3DMainCanvas *)appPtr;
	canvas.LoadGeneral(wfn,NULL);
}
