// Lighting
//	Input variables: vec4 color
//	                 vec3 nomLocal
//	                 vec3 vecToCamera <- must be normalized
//	Output variable: vec4 accumColor

"YS_GLSL_HIGHP" vec3 accumColor;
accumColor=ambientColor*color.xyz;

for(int lightNo=0; lightNo<YSGLSL_MAX_NUM_LIGHT; lightNo++)
{
	if(true==lightEnabled[lightNo])
	{
		"YS_GLSL_MIDP" float diffuseIntensity=max(dot(nomLocal,lightPos[lightNo].xyz),0.0);
		accumColor+=diffuseIntensity*(color.xyz*lightColor[lightNo]);

		"YS_GLSL_HIGHP" vec3 mid=normalize(lightPos[lightNo].xyz+vecToCamera);
		"YS_GLSL_HIGHP" float specularIntensity=pow(max(dot(mid,nomLocal),0.0),specularExponent);
		accumColor+=specularIntensity*specularColor;
	}
}
