#include "../ysfileinfo.h"
#include "../ysencoding.h"
#include <windows.h>


YSRESULT YsFileList::FindFileList(const char path[],const char prefix[],const char postfix[])
{
	YsWString wPath,wPrefix,wPostfix;
	if(NULL!=path)
	{
		YsSystemEncodingToUnicode(wPath,path);
	}
	if(NULL!=prefix)
	{
		YsSystemEncodingToUnicode(wPrefix,prefix);
	}
	if(NULL!=postfix)
	{
		YsSystemEncodingToUnicode(wPostfix,postfix);
	}
	return FindFileList(wPath,wPrefix,wPostfix);
}

YSRESULT YsFileList::FindFileList(const wchar_t path[],const wchar_t prefix[],const wchar_t postfix[])
{
	Initialize();


	HANDLE hFind;
	YsWString fn,fulDir,tst;


	if(NULL!=prefix)
	{
		uPrefix.Set(prefix);
	}
	else
	{
		uPrefix.Set(L"");
	}
	if(NULL!=postfix)
	{
		uPostfix.Set(postfix);
	}
	else
	{
		uPostfix.Set(L"");
	}
	uPrefix.Uncapitalize();
	uPostfix.Uncapitalize();
	this->path.Set(path);


	fulDir.Set(path);
	if(0<fulDir.Strlen() && '\\'!=fulDir.LastChar() && '/'!=fulDir.LastChar())
	{
		fulDir.Append(L"\\");
	}
	fulDir.Append(prefix);
	fulDir.Append(L"*");
	fulDir.Append(postfix);

	hFind=NULL;
	for(;;)
	{
		WIN32_FIND_DATAW fd;

		if(NULL==hFind)
		{
			hFind=FindFirstFileW(fulDir,&fd);
			if(INVALID_HANDLE_VALUE==hFind)
			{
				return YSERR;
			}
		}
		else
		{
			if(TRUE!=FindNextFileW(hFind,&fd))
			{
				break;
			}
		}

		YSBOOL isDir=YSFALSE;
		unsigned long sizeHigh=0,sizeLow=0;
		if(0!=(FILE_ATTRIBUTE_DIRECTORY&fd.dwFileAttributes))
		{
			isDir=YSTRUE;
			sizeHigh=0;
			sizeLow=0;
		}
		else
		{
			isDir=YSFALSE;
			sizeHigh=fd.nFileSizeHigh;
			sizeLow=fd.nFileSizeLow;
		}

		TestAndAddFileInfo(fd.cFileName,isDir,sizeHigh,sizeLow);
	}

	if(NULL!=hFind)
	{
		FindClose(hFind);
	}

	return YSOK;
}


